; 
    .686
    include j:\masm32\include\masm32rt.inc                      ; <<< set correct disk path!!!
    include timers.asm

    filecmp_heapbuffers         PROTO
    filecmp_filemapping         PROTO
    filecmp_nobuffering         PROTO
    filecmp_nobuffering_async   PROTO
    cmpmem                      PROTO :DWORD,:DWORD,:DWORD
    StringCopy                  PROTO

; 
    .data
      testfile          db "j:\masm32\include\windows.inc",0    ; <<< set correct disk path!!!
      totalfiles        dd 0

      NAME_LENGTH       EQU totalfiles - testfile

    .data?
      copyfiles         db (NAME_LENGTH*80) dup (?)
      bytesPerSector    dd ?
      bytesRead         dd ?
      hFile             dd ?
      lof1              dd ?
      lpMem1            dd ?        ; use as 2 consecutive DWORDs for GetDiskFreeSpaceEx
      lpMem2            dd ?
      namepointer       dd ?        ; pointer into filename array

    .code
; 
start:
; 

    ; Determine sector-size value for disk

    print "Reading test file...",13,10

    mov eax, DWORD PTR testfile     ; get start of testfile path string
    push ebx
    push edi
    push esi
    mov ebx, INVALID_HANDLE_VALUE   ; INVALID_HANDLE_VALUE = -1
    and eax, 0ffffffH               ; reduce path to drivename string eg. "C:\"
    mov esi, ebx
    mov DWORD PTR copyfiles, eax    ; use for temp storage
    invoke GetDiskFreeSpace, ADDR copyfiles,     ; only bytesPerSector needed
                             ADDR lof1,
                             ADDR bytesPerSector,
                             ADDR lpMem1,
                             ADDR lpMem2
    add ebx, bytesPerSector
    mov bytesPerSector, ebx         ; make MOD value from power of 2 returned

    invoke CreateFile, ADDR testfile,
                       GENERIC_READ,
                       FILE_SHARE_READ,
                       NULL,
                       OPEN_EXISTING,
                       FILE_ATTRIBUTE_NORMAL,
                       NULL
    mov hFile, eax
    cmp eax, esi
    jne @F

    print "Unable to open masm32\include\windows.inc",13,10
    jmp filereadexit
@@:
    invoke GetFileSize, hFile, NULL
    mov lof1, eax
    add eax, ebx                    ; round up beyond sector-end
    mov ecx, 81                     ; 80 copies and one spare
    mul ecx
    mov edi, eax                    ; low dword of space needed
    mov esi, edx                    ; high dword
    invoke GetDiskFreeSpaceEx, ADDR copyfiles, ADDR lpMem1, NULL, NULL
    mov eax, lpMem1                 ; low dword of free space returned
    mov ecx, lpMem2                 ; high dword
    sub eax, edi
    sbb ecx, esi
    jnb @F

    print "Not enough disk space to copy test files",13,10
    invoke CloseHandle, hFile
    jmp filereadexit
@@:
    mov esi, lof1
    invoke VirtualAlloc, NULL, esi, MEM_COMMIT, PAGE_READWRITE
    mov lpMem1, eax                 ; EAX returns pointer or NULL if unsuccessful
    test eax, eax
    jnz @F

    print "Unable to allocate buffer memory",13,10
    invoke CloseHandle, hFile
    jmp filereadexit
@@:
    invoke ReadFile, hFile, lpMem1, esi, ADDR bytesRead, NULL
    invoke CloseHandle, hFile
    cmp bytesRead, esi
    je @F

    print "Error reading windows.inc",13,10
    jmp filereadexit2
@@:
    mov ecx, ebx
    test esi, ebx                   ; is file sector-multiple length
    jz @F

    not ecx
    add esi, ebx                    ; round up write length, this is safe because
    and esi, ecx                    ; VirtualAlloc allocates in full pages

; For simplicity, we will leave the files over-written to the next sector end. This is
; necessary because we are using FILE_FLAG_NO_BUFFERING which demands full sector writes.
; Normally, we should close the files and reopen without that flag, so we can set the
; filepointer to the correct end value and use SetEndOfFile to truncate them to length.

@@:
    lea edi, copyfiles
    mov ebx, "100"                  ; split file number
    mov namepointer, edi            ; set start pointer into array
    print "Creating comparison files...",13,10,13,10

createcopyfiles:
    lea eax, testfile
    mov edx, edi
    invoke StringCopy
    mov ecx, 0ff0000H               ; mask for last digit of extension
    mov [edx-3], ebx                ; copy split number extension into name
    and ecx, ebx
    add ebx, 10000H                 ; add 1 to last digit
    cmp ecx, 390000H                ; test last digit = "9"
    jne @F
    add ebx, 0fff60100H             ; clock -10 last digit, +1 second
@@:
    mov ecx, edi                    ; save this pointer
    add edi, NAME_LENGTH            ; get next pointer
    invoke CreateFile, ecx,
                       GENERIC_WRITE,
                       NULL,
                       NULL,
                       CREATE_NEW,
                       FILE_ATTRIBUTE_NORMAL+FILE_FLAG_NO_BUFFERING,
                       NULL
    mov hFile, eax
    cmp eax, INVALID_HANDLE_VALUE
    jne @F

    print "Error copying test files",13,10
    jmp filecleanup
@@:
    invoke WriteFile, eax, lpMem1, esi, ADDR bytesRead, NULL
    test eax, eax                   ; returns non-zero for valid write
    jnz @F

    print "Error copying test files",13,10
    jmp filecleanup
@@:
    add DWORD PTR totalfiles, 1
    invoke CloseHandle, hFile
    cmp ebx, "180"                  ; did we copy 80 files yet
    jne createcopyfiles

    ; Do compare tests on 80 identical but different unbuffered files

    invoke Sleep,1000

    LOOP_COUNT equ 20
    print "filecmp_heapbuffers: "
    timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke filecmp_heapbuffers
      xor edx, edx
      test eax, eax
      js filereaderror
      add DWORD PTR namepointer, NAME_LENGTH
    timer_end
    push eax
    push eax
    push eax
    print ustr$(eax),"ms",13,10,13,10

    invoke Sleep,1000

    print "filecmp_filemapping: "
    timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke filecmp_filemapping
      mov edx, 3
      test eax, eax
      js filereaderror
      add DWORD PTR namepointer, NAME_LENGTH
    timer_end
    push eax
    print ustr$(eax),"ms - "

    fild DWORD PTR[esp]
    fild DWORD PTR[esp+4]
    fdiv
    fld8 100.0
    fmul
    fstp QWORD PTR[esp]
    pop eax
    pop edx

    invoke crt_printf,chr$("%.1f%%%c%c"),edx::eax,10,10

    invoke Sleep,1000

    print "filecmp_nobuffering: "
    timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke filecmp_nobuffering
      mov edx, 2
      test eax, eax
      js filereaderror
      add DWORD PTR namepointer, NAME_LENGTH
    timer_end
    push eax
    print ustr$(eax),"ms - "

    fild DWORD PTR[esp]
    fild DWORD PTR[esp+4]
    fdiv
    fld8 100.0
    fmul
    fstp QWORD PTR[esp]
    pop eax
    pop edx

    invoke crt_printf,chr$("%.1f%%%c%c"),edx::eax,10,10

    invoke Sleep,1000

    print "filecmp_nobuffering_async: "
    timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke filecmp_nobuffering_async
      mov edx, 1
      test eax, eax
      js filereaderror
      add DWORD PTR namepointer, NAME_LENGTH
    timer_end
    push eax
    print ustr$(eax),"ms - "

    fild DWORD PTR[esp]
    fild DWORD PTR[esp+4]
    fdiv
    fld8 100.0
    fmul
    fstp QWORD PTR[esp]
    pop eax
    pop edx

    invoke crt_printf,chr$("%.1f%%%c%c"),edx::eax,10,10

filecleanup:
    mov ebx, totalfiles             ;delete as many files as there are totalfiles
    lea edi, copyfiles
    test ebx, ebx
    jz filereadexit
@@:
    invoke DeleteFile, edi
    add edi, NAME_LENGTH
    sub ebx, 1
    jnz @B

filereadexit2:
    invoke VirtualFree, lpMem1, NULL, MEM_RELEASE

filereadexit:
	mov	eax, input(13,10," Press ENTER to exit...")
    pop esi
    pop edi
    pop ebx
    exit

filereaderror:
    sub edx, 1
    js @F
    pop eax
    jmp filereaderror
@@:
    print "error reading test file",13,10,13,10
    jmp filecleanup

; 
; This proc performs a binary comparison of two files, returning 0
; if the files are different, 1 if the files are byte identical, or
; INVALID_HANDLE_VALUE (-1) if there is a problem opening either
; of the files.
; 

align 16

filecmp_heapbuffers proc

; uses EBX/EDI/ESI

    mov ebx, INVALID_HANDLE_VALUE   ; INVALID_HANDLE_VALUE = -1
    invoke CreateFile, namepointer,
                       GENERIC_READ,
                       FILE_SHARE_READ,
                       NULL,
                       OPEN_EXISTING,
                       FILE_ATTRIBUTE_NORMAL,
                       NULL
    mov hFile, eax
    cmp eax, ebx
    je heapbuffers_error

    mov esi, lof1
    invoke GetProcessHeap
    mov edi, eax
    invoke HeapAlloc, eax, 0, esi
    mov lpMem2, eax

    invoke ReadFile, hFile, lpMem2, esi, ADDR bytesRead, NULL
    cmp bytesRead, esi
    jne heapbuffers_error2

    invoke cmpmem, lpMem1, lpMem2, esi
    mov ebx, eax

heapbuffers_error2:
    invoke HeapFree, edi, 0, lpMem2
    invoke CloseHandle, hFile
    mov eax, ebx

heapbuffers_error:
    ret

filecmp_heapbuffers endp

; 
; This proc performs a binary comparison of two files, returning
; 0 if the files are different, 1 if the files are byte identical,
; or INVALID_HANDLE_VALUE (-1) if there is a problem opening
; either of the files.
; 

align 16

filecmp_filemapping proc

; uses EBX

    LOCAL hMMF2:DWORD

    mov ebx, INVALID_HANDLE_VALUE   ; INVALID_HANDLE_VALUE = -1
    invoke CreateFile, namepointer,
                       GENERIC_READ,
                       FILE_SHARE_READ,
                       NULL,
                       OPEN_EXISTING,
                       FILE_ATTRIBUTE_NORMAL,
                       NULL
    mov hFile, eax
    cmp eax, ebx
    je filemapping_error

    invoke CreateFileMapping, eax, NULL, PAGE_READONLY, 0, 0, NULL
    test eax, eax                   ; returns valid handle if successful
    jz filemapping_error2
    mov hMMF2, eax
    invoke MapViewOfFile, eax, FILE_MAP_READ, 0, 0, 0
    mov lpMem2, eax

    invoke cmpmem, lpMem1, eax, lof1
    mov ebx, eax

    invoke UnmapViewOfFile, lpMem2
    invoke CloseHandle, hMMF2

filemapping_error2:    
    invoke CloseHandle,hFile
    mov eax, ebx

filemapping_error:    
    ret

filecmp_filemapping endp

; 

align 16

filecmp_nobuffering proc

; uses EBX/EDI/ESI

    LOCAL memStart:DWORD

    mov ebx, INVALID_HANDLE_VALUE   ; INVALID_HANDLE_VALUE = -1
    invoke CreateFile, namepointer,
                       GENERIC_READ,
                       FILE_SHARE_READ,
                       NULL,
                       OPEN_EXISTING,
                       FILE_ATTRIBUTE_NORMAL+FILE_FLAG_NO_BUFFERING,
                       NULL
    mov hFile, eax
    cmp eax, ebx
    je nobuffering_error

    ; Get file size and round up to multiple of sector size

    mov edi, bytesPerSector     ; get MOD value from disk sector size
    mov eax, lof1               ; get real length of file
    mov ecx, edi
    test eax, edi               ; is there a remainder
    jz  @F

    not ecx
    add eax, edi                ; add sector-length - 1
    and eax, ecx                ; round up to next sector-length
@@:
    mov esi, eax                ; save correct sector-multiple read length

    ; Allocate memory and calc sector-aligned start address

    invoke GetProcessHeap
    lea ecx, [edi+esi]          ; max needed memsize is rounded length + (sector-1)
    push eax
    invoke HeapAlloc, eax, 0, ecx
    mov lpMem2, eax
    mov ecx, edi
    test eax, edi               ; is mem allocation sector-aligned
    jz  @F

    not ecx
    add eax, edi                ; add sector-length - 1
    and eax, ecx                ; round up to next sector-multiple start
@@:
    mov memStart, eax

    invoke ReadFile, hFile, eax, esi, ADDR bytesRead, NULL
    cmp bytesRead, esi
    jne nobuffering_error2

    invoke cmpmem, lpMem1, memStart, lof1
    mov ebx, eax

nobuffering_error2:
    pop eax
    invoke HeapFree, eax, 0, lpMem2
    invoke CloseHandle, hFile
    mov eax, ebx

nobuffering_error:
    ret

filecmp_nobuffering endp

; 

align 16

filecmp_nobuffering_async proc

; uses EBX/EDI/ESI

    LOCAL memStart:DWORD
    LOCAL overlapped_read:OVERLAPPED

    mov ebx, INVALID_HANDLE_VALUE   ; INVALID_HANDLE_VALUE = -1
    invoke CreateFile, namepointer,
                       GENERIC_READ,
                       FILE_SHARE_READ,
                       NULL,
                       OPEN_EXISTING,
                       FILE_ATTRIBUTE_NORMAL+FILE_FLAG_NO_BUFFERING+FILE_FLAG_OVERLAPPED,
                       NULL
    mov hFile, eax
    cmp eax, ebx
    je nobuffering_async_error

    ; Get file size and round up to multiple of sector size

    mov edi, bytesPerSector     ; get MOD value from disk sector size
    mov eax, lof1               ; get real length of file
    mov ecx, edi
    test eax, edi               ; is there a remainder
    jz  @F

    not ecx
    add eax, edi                ; add sector-length - 1
    and eax, ecx                ; round up to next sector-length
@@:
    mov esi, eax                ; save correct sector-multiple read length

    ; Allocate memory and calc sector-aligned start address

    invoke GetProcessHeap
    lea ecx, [edi+esi]          ; max needed memsize is rounded length + (sector-1)
    push eax
    invoke HeapAlloc, eax, 0, ecx
    mov lpMem2, eax
    mov ecx, edi
    test eax, edi               ; is mem allocation sector-aligned
    jz  @F

    not ecx
    add eax, edi                ; add sector-length - 1
    and eax, ecx                ; round up to next sector-multiple start
@@:
    mov memStart, eax

    invoke CreateEvent, NULL, TRUE, FALSE, NULL
    xor ecx, ecx

    mov overlapped_read.hEvent, eax
    mov overlapped_read.loffset, ecx
    mov overlapped_read.OffsetHigh, ecx

    ;;ERROR_IO_PENDING = 997
    invoke ReadFile, hFile, memStart, esi, ADDR bytesRead, ADDR overlapped_read
    test eax, eax               ; check valid asynchronous read on return
    jnz @F                      ; OK if return value is non-zero
    invoke GetLastError
    cmp eax, ERROR_IO_PENDING   ; or if the read is still pending
    jne nobuffering_async_error2
@@:
    invoke GetOverlappedResult, hFile, ADDR overlapped_read, ADDR bytesRead, TRUE
    cmp bytesRead, esi
    jne nobuffering_async_error2

    invoke cmpmem, lpMem1, memStart, lof1
    mov ebx, eax

nobuffering_async_error2:
    pop eax
    invoke HeapFree, eax, 0, lpMem2
    invoke CloseHandle, overlapped_read.hEvent
    invoke CloseHandle, hFile
    mov eax, ebx

nobuffering_async_error:
    ret

filecmp_nobuffering_async endp

; 

align 16

cmpmem proc buf1:DWORD,buf2:DWORD,bcnt:DWORD

    push esi
    push edi

    mov edx, bcnt
    shr edx, 2                      ; div by 4

    mov esi, buf1
    mov edi, buf2
    xor ecx, ecx

  align 4
  @@:
    mov eax, [esi+ecx]              ; DWORD compare main file
    cmp eax, [edi+ecx]
    jne fail
    add ecx, 4
    sub edx, 1
    jnz @B

    mov edx, bcnt                   ; calculate any remainder
    and edx, 3
    jz match                        ; exit if its zero
    xor eax, eax                    ; clear EAX for partial writes

  @@:
    mov al, [esi+ecx]               ; BYTE compare tail
    cmp al, [edi+ecx]
    jne fail
    add ecx, 1
    sub edx, 1
    jnz @B

    jmp match

  fail:
    xor eax, eax                    ; return zero if DIFFERENT
    jmp quit

  match:
    mov eax, 1                      ; return NON zero if SAME

  quit:
    pop edi
    pop esi

    ret

cmpmem endp

; 

align 16

StringCopy    proc

 comment    * -----------------------------------------------------------------------------
            Quick null-terminated byte-based string copy, no parameter checks, by IanB.

            On entry:
                EAX = source pointer
                EDX = destination pointer
            On exit:
                EAX = length of string copied (not including final zero-termination)
                ECX/EDX point to zero-termination bytes in source/destination
            EBX/EBP/EDI/ESI preserved.
            ----------------------------------------------------------------------------- *

        neg     eax
        neg     edx
        push    eax
        not     eax                 ; NEG then NOT is equivalent to SUB 1
        not     edx
@@:
        mov     cl, [eax+1]
        add     edx, 1
        add     eax, 1
        mov     [edx], cl
        test    cl, cl
        jnz     @B

        mov     ecx, eax            ; return end position for reference
        pop     eax
        add     eax, ecx            ; subtract start position from end
        ret

StringCopy endp

; 
end start

